import java.util.*;
import java.awt.Color;

public class Checker {
    
    ShapeCanvas canvas;
    public List<Rule> path;
    int pointer = 0;
    
    public void reset() {
        pointer = 0;
        canvas.reset();
        System.out.println("--RESET--");
        MainGame.update();
    }
    
    public Rule pop() {
        Rule r = peek();
        if (r == null) return null;
        pointer++;
        return r;
    }
    
    public Rule peek() {
        if (pointer >= 0 && pointer < path.size())
            return path.get(pointer);
        return null;
    }
    
    public Checker(ShapeCanvas canvas) {
        this.canvas = canvas;
        // this.path = this.makePath();
    }
    
    // make path
    public void makePath() {
        
        int rows = canvas.rows;
        int columns = canvas.columns;
        path = new ArrayList<>();
        
        int numShapes = rows * columns;
        boolean visited[] = new boolean[numShapes];
        
        // get last shape
        int last = random(numShapes);
        visited[last] = true;
        
        for (int i = 1; i < numShapes; ++i) {
            // create path
            while (true) {
                int rand = random(numShapes);
                if (visited[rand]) continue;

                int rx = rand / columns;
                int ry = rand % columns;
                
                int isShape = random(2);
                if (isShape == 1) {
                    path.add(new Rule(canvas.shapes[rx][ry].type));
                }
                else {
                    path.add(new Rule(canvas.shapes[rx][ry].color));
                }
                
                visited[rand] = true;
                break;
            }
            
        }
        
        
        
        int lastx = last / columns;
        int lasty = last % columns;
        Shape lastShape = canvas.shapes[lastx][lasty];
        path.add(new Rule(lastShape.type, lastShape.color));
        
        // System.out.println(path);
        reset();
        
    }
    
    static int random(int max) {
        return (int) (Math.random() * max);
    }
    
}
