import java.awt.*;
import javax.swing.*;

public class MainGame extends JFrame {
    
    public static MainGame CurrentGame = null;
    public static int DEFAULT_WINDOW_X = 650;
    public static int DEFAULT_WINDOW_Y = 650;
    
    public ShapeCanvas canvas;
    public Checker checker;
    public static String title = "PATHERN";
    
    public int shapeCount, colorCount;
    
    public static void main(String[] args) {
        MainGame game = new MainGame(650, 650, 12, 12, -1, -1);
        game.setVisible(true);
    }
    
    public static ShapeCanvas getCanvas() {
        return CurrentGame.canvas;
    }
    
    public static Checker getChecker() {
        return CurrentGame.checker;
    }
    
    public void retitle ()
    {
        setTitle(title);
    }
    
    public RuleView ruleview = new RuleView();
    
    public static RuleView getRuleView() {
        return CurrentGame.ruleview;
    }
    
    public static void update() {
        

        if (getChecker().peek() == null) {
            getCanvas().repaint();
            
            title = "YOU WIN!";
            
            JOptionPane.showMessageDialog(MainGame.CurrentGame, "YOU WIN!");
            System.exit(0);
        }
        else
        {
            Rule r = getChecker().peek();
            getRuleView().setRule(r);
            System.out.println("Rule: " + r);
            title = ("Rule: " + getChecker().peek());
        }
        

        //JOptionPane.showMessageDialog(MainGame.CurrentGame, ("Rule: " + getChecker().peek()));

        getCanvas().repaint();
    }
    
    public MainGame(int windowX, int windowY, int rows, int columns, int shapeCount, int colorCount) {
        CurrentGame = this;
        
        setSize(windowX, windowY);
        setResizable(false);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setTitle(title);
        
        if (shapeCount == -1)
            shapeCount = Integer.MAX_VALUE;
        if (colorCount == -1)
            colorCount = Integer.MAX_VALUE;
        
        canvas = new ShapeCanvas(rows, columns, shapeCount, colorCount);
        checker = new Checker(canvas);
        
        add(canvas);
    }
    
    public MainGame(int rows, int columns, int shapeCount, int colorCount) {
        this(DEFAULT_WINDOW_X, DEFAULT_WINDOW_Y, rows, columns, shapeCount, colorCount);
    }
    
}