import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class MainMenu extends JFrame {
    
    public static void main(String[] args) {
        MainMenu menu = new MainMenu(600, 200);
        menu.setVisible(true);
    }
    
    //Store data
    public int size;
    public int shape;
    public int color;
    
    public boolean hasSize = false;
    public boolean hasShape = false;
    public boolean hasColor = false;
    
    //JLabels used
    JLabel lbIntro = new JLabel ("Select Size, Number of Shapes, and Number of Colors",SwingConstants.CENTER);
    
    //JButtons used
    JButton[] btSI = new JButton[13]; // 3 to 12
    JButton[] btSH = new JButton[11]; // 10 to 5
    JButton[] btCO = new JButton[11]; // 10 to 5
    
    //JPanels used
    JPanel pnAll = new JPanel(new GridLayout(5,1,5,5));
    JPanel pnLRTop = new JPanel(new GridLayout(1,2));
    JPanel pnLRBot = new JPanel(new GridLayout(1,2));
    JPanel pnSizeTop = new JPanel(new GridLayout(1,5));
    JPanel pnSizeBot = new JPanel(new GridLayout(1,5));
    JPanel pnColorTop = new JPanel(new GridLayout(1,3));
    JPanel pnColorBot = new JPanel(new GridLayout(1,3));
    JPanel pnShapeTop = new JPanel(new GridLayout(1,3));
    JPanel pnShapeBot = new JPanel(new GridLayout(1,3));

    public MainMenu(int windowX, int windowY) {
        
        setSize(windowX, windowY);
        setResizable(false);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setTitle("PATHERN");
        
        //Creating the JButtons
        for (int init = 0; init < btSI.length; init++)
        {
            btSI[init] = new JButton (init + "x" + init);
        }
        for (int init = 0; init < btSH.length; init++)
        {
            btSH[init] = new JButton (init + " Shapes");
        }
        for (int init = 0; init < btCO.length; init++)
        {
            btCO[init] = new JButton (init + " Colors");
        }
        
        //Adding the JButtons
        for (int init = 3; init < btSI.length; init++)
        {
            btSI[init].addActionListener(new ActionListener()
            {
                @Override
                public void actionPerformed(ActionEvent e)
                {
                    JButton button = (JButton) e.getSource();
                    hasSize = true;
                    size = Integer.parseInt(button.getText().substring(0, button.getText().indexOf('x')));
                    update();
                }
            });
            if (init < 8)
                pnSizeTop.add(btSI[init]);
            else
                pnSizeBot.add(btSI[init]);
        }
        for (int init = btSH.length-1; init >= 5; init--)
        {
            btSH[init].addActionListener(new ActionListener()
                                         {
                @Override
                public void actionPerformed(ActionEvent e)
                {
                    JButton button = (JButton) e.getSource();
                    hasShape = true;
                    shape = Integer.parseInt(button.getText().substring(0, button.getText().indexOf(' ')));
                    update();
                }
            });
            
            if (init > 7)
                pnShapeTop.add(btSH[init]);
            else
                pnShapeBot.add(btSH[init]);
        }
        for (int init = btCO.length-1; init >= 5; init--)
        {
            btCO[init].addActionListener(new ActionListener()
                                         {
                @Override
                public void actionPerformed(ActionEvent e)
                {
                    JButton button = (JButton) e.getSource();
                    hasColor = true;
                    color = Integer.parseInt(button.getText().substring(0, button.getText().indexOf(' ')));
                    update();
                }
            });
            
            if (init > 7)
                pnColorTop.add(btCO[init]);
            else
                pnColorBot.add(btCO[init]);
        }
        
        pnLRTop.add(pnColorTop);
        pnLRTop.add(pnShapeTop);
        
        pnLRBot.add(pnColorBot);
        pnLRBot.add(pnShapeBot);
        
        
        lbIntro.setFont(new Font(lbIntro.getFont().getFontName(), Font.BOLD, lbIntro.getFont().getSize()));
        pnAll.add(lbIntro);
        pnAll.add(pnSizeTop);
        pnAll.add(pnSizeBot);
        pnAll.add(pnLRTop);
        pnAll.add(pnLRBot);
        
        add(pnAll);

        
    }
    
    public void update()
    {
        //Update String (lbIntro)
        
        if (hasColor && hasShape && hasSize)
            new MainGame(size, size, shape, color).setVisible(true);
            
    }
}