import java.awt.Color;

class Rule {
    // can have null
    public String shape;
    public Color color;
    public Rule(String s) {
        this.shape = s;
        this.color = null;
    }
    public Rule(Color c) {
        this.shape = null;
        this.color = c;
    }
    public Rule(String s, Color c) {
        this.shape = s;
        this.color = c;
    }
    public String toString() {
        StringBuilder sb = new StringBuilder();
        if (shape != null) {
            sb.append(shape);
        }
        if (color != null) {
            if (shape != null)
                sb.append('|');
            sb.append(ShapeCanvas.EnglishColors.get(color));
            // sb.append(color.toString()); // translate to english
        }
        return sb.toString();
    }
    public boolean meets(Shape s) {
        //if (this.shape != null && this.color != null)
        //    return s.type == this.shape && this.color.equals(s.color);
        return (this.shape != null && this.shape.equals(s.type)) || (this.color != null && this.color.equals(s.color));
    }
}