import java.awt.*;
import javax.swing.*;

public class RuleView extends JFrame {
    
    public RuleCanvas canvas;
    
    public JLabel label, other;
    
    public RuleView() {
        setSize(200, 200);
        setResizable(true);
        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        
        canvas = new RuleCanvas();
        getContentPane().setLayout(new GridLayout(3, 1));
        
        label = new JLabel("Next:");
        other = new JLabel();
        
        
        
        this.add(label);
        this.add(canvas);
        this.add(other);
        this.setAlwaysOnTop(true);
        this.setVisible(true);
    }
    
    public void setRule(Rule rule) {
        other.setText(rule.toString());
        canvas.setRule(rule);
        canvas.repaint();
        this.pack();
    }
    
    class RuleCanvas extends Canvas {
        public Rule rule;
        public void setRule(Rule rule) {
            this.rule = rule;
            this.repaint();
        }
        @Override
        public void paint(Graphics g) {
            if (rule == null) return;
            if (rule.shape != null) {
                // draw shape
                Color c = (rule.color == null ? Color.BLACK : rule.color);
                new Shape(100, 25, 25, rule.shape, c).draw(g);
            }
            else if (rule.color != null) {
                g.setColor(rule.color);
                g.fillRect(0, 0, RuleView.this.getWidth(), RuleView.this.getHeight());
            }
        }
    }
                 
}
